package sun.font;

import java.awt.font.FontRenderContext;
import java.awt.Font;

public abstract class TextSource
{
    public static final boolean WITHOUT_CONTEXT = false;
    public static final boolean WITH_CONTEXT = true;
    
    public TextSource() {
    }
    
    public abstract char[] getChars();
    
    public abstract int getStart();
    
    public abstract int getLength();
    
    public abstract int getContextStart();
    
    public abstract int getContextLength();
    
    public abstract int getLayoutFlags();
    
    public abstract int getBidiLevel();
    
    public abstract Font getFont();
    
    public abstract FontRenderContext getFRC();
    
    public abstract CoreMetrics getCoreMetrics();
    
    public abstract TextSource getSubSource(int p0, int p1, int p2);
    
    public abstract String toString(boolean p0);
}
